import java.util.*;

public class ExceptionQueueSingleton {
    private static ExceptionQueueSingleton instance = 
        new ExceptionQueueSingleton();
    private ArrayList exceptionQueue = new ArrayList();

    private ExceptionQueueSingleton() {
    }

    public static ExceptionQueueSingleton getInstance() {
        return instance;
    }

    public synchronized void addThrowable(Throwable exc) {
        exceptionQueue.add(exc);
    }

    public Iterator getExceptionQueueIterator() {
        return exceptionQueue.iterator();
    }
}
